package com.zksy.controller.property;

import cn.hutool.core.date.DateTime;
import com.zksy.property.domain.AEquipmentLedger;
import com.zksy.property.service.AEquipmentLedgerService;
import com.zksy.utils.AjaxResult;
import com.zksy.utils.ExcelExportUtil;
import com.zksy.utils.ExcelImportUtil;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.multipart.MultipartFile;

import javax.servlet.http.HttpServletResponse;
import java.time.LocalDate;
import java.time.LocalDateTime;
import java.util.Arrays;

/**
 * @author Administrator
 * @version 1.0
 * @project enterprise-assets-service
 * @description 资产信息管理控制层
 * @date 2025/6/24 14:33:13
 */
@RestController
@RequestMapping("/AEquipmentLedger")
@Api(tags = "设备台账",description = "设备台账desc")
public class AEquipmentLedgerController {
    @Autowired
    private AEquipmentLedgerService service;
    @GetMapping("/findByPage")
    @ApiOperation(value = "设备台账查询分页")
    public AjaxResult findByPage(long pageNum, long pageSize, String equipmentId,String equipmentName,String equipmentType,String activeState){
        return AjaxResult.success(service.findByPage(pageNum, pageSize, equipmentId,equipmentName,equipmentType,activeState));
    }
    @GetMapping("/getAEquipmentLedgerList")
    @ApiOperation(value = "设备台账查询")
    public AjaxResult getAEquipmentLedgerList( String equipmentId,String equipmentName,String equipmentType,String activeState){
        return AjaxResult.success(service.getAEquipmentLedgerList(equipmentId,equipmentName,equipmentType,activeState));
    }
    @GetMapping("/getById/{id}")
    @ApiOperation(value = "根据Id查询设备台账")
    public AjaxResult getById(@PathVariable String id){
        return AjaxResult.success(service.getById(id));
    }
    @PostMapping("/save")
    @ApiOperation(value = "设备台账保存")
    public AjaxResult save(@RequestBody AEquipmentLedger aassetManagement) {
        return service.save(aassetManagement) ? AjaxResult.success(aassetManagement) : AjaxResult.error("保存失败");
    }
    @PostMapping("/update")
    @ApiOperation(value = "设备台账修改")
    public AjaxResult update(@RequestBody AEquipmentLedger aassetManagement) {
        aassetManagement.setUpdateTime(LocalDateTime.now());
        return service.updateById(aassetManagement) ? AjaxResult.success(aassetManagement) : AjaxResult.error("修改失败");
    }
    @PostMapping("/deleteBatch")
    @ApiOperation(value = "设备台账删除")
    public AjaxResult delete(@RequestBody String[] ids) {
        return service.removeBatchByIds(Arrays.asList(ids)) ? AjaxResult.success("删除成功") : AjaxResult.error("删除失败");
    }
    @PostMapping("/importData")
    @ApiOperation(value = "导入数据")
    public AjaxResult importData(MultipartFile file) {
        return AjaxResult.success(service.saveOrUpdateBatch(ExcelImportUtil.importExcel(file, AEquipmentLedger.class)));
    }
    @GetMapping("/exportData")
    @ApiOperation(value = "导出数据")
    public void exportData(HttpServletResponse response, String equipmentId,String equipmentName,String equipmentType,String activeState) {
        ExcelExportUtil.exportExcel(response,service.getAEquipmentLedgerList(equipmentId,equipmentName,equipmentType,activeState), AEquipmentLedger.class, "设备台账","设备台账");
    }

}
